package BanquePackage;

import java.util.Vector;

/*
 * pre:montant>0
 *
 * pre:montant>0
 *
 * post:solde=solde@pre+montant
 *
 * pre:montant>0 and
 * montant<=solde-plancher
 *
 * post:solde=solde@pre-montant
 *
 * inv:solde>=plancher
 */
  /*
 * pre:montant>0
 *
 * pre:montant>0
 *
 * post:solde=solde@pre+montant
 *
 * pre:montant>0 and
 * montant<=solde-plancher
 *
 * post:solde=solde@pre-montant
 *
 * inv:solde>=plancher
 */
  /**
   * @invariant livretContrainte: self . livret -> notEmpty implies self . proprietaire . age <= 28
   */
public class Compte {
  /* {src_lang=Java}*/
protected int id;

    protected double solde;
  /* {transient=false, volatile=false}*/

  protected double plancher;
  /* {transient=false, volatile=false}*/

    protected double remuneration = solde*0.005;
  /* {transient=false, volatile=false}*/

    public Personne proprietaire;
    public Vector  livret=new Vector();
    public Personne gestionnaire;


  public int getId_wrappedbyocl_BanquePackage_Compte(){return id;}

  public void setId_wrappedbyocl_BanquePackage_Compte(int id){this.id=id;}

  /**
   * @precondition debitContrainte: montant < solde - plancher
   * @postcondition debitContrainte_1: solde = solde @ pre - montant
   */
  public void debiter_wrappedbyocl_BanquePackage_Compte(int montant) {solde-=montant;
  }

      /**
   * @precondition newConstraint_0: montant > 0
   * @postcondition newConstraint_1: solde = solde @ pre + montant
   */
  public void crediter_wrappedbyocl_BanquePackage_Compte(int montant) {solde+=montant;
  }

  public double getSolde_wrappedbyocl_BanquePackage_Compte() {
  return solde;
  }

  public Compte(tudresden.ocl.injection.lib.WrapperDummy wrappedbyocl) {
  }

  public void setProprietaire_wrappedbyocl_BanquePackage_Compte(Personne p) {proprietaire=p;
  }

      /**
   * @precondition newConstraint_0: livret -> excludes ( l )
   * @postcondition newConstraint_1: livret -> includes ( l )
   */
  public void addLivret_wrappedbyocl_BanquePackage_Compte(Livret l) {
  livret.add(l);}
/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #getId_wrappedbyocl_BanquePackage_Compte()
*/public int getId(){
int result;
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
result=getId_wrappedbyocl_BanquePackage_Compte();
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
result=getId_wrappedbyocl_BanquePackage_Compte();
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
return result;
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #setId_wrappedbyocl_BanquePackage_Compte(int)
*/public void setId(int id){
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
setId_wrappedbyocl_BanquePackage_Compte(id);
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
setId_wrappedbyocl_BanquePackage_Compte(id);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #debiter_wrappedbyocl_BanquePackage_Compte(int)
*/public void debiter(int montant)throws Exception{
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
debiter_wrappedbyocl_BanquePackage_Compte(montant);
else{
checkForChangedFeatures();
tudresden.ocl.lib.OclReal tudOclNode15;
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{final tudresden.ocl.lib.OclAnyImpl tudOclNode8=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar0=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclReal tudOclNode9=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode8.getFeature("solde"));
final tudresden.ocl.lib.OclReal tudOclNode10=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode8.getFeature("plancher"));
final tudresden.ocl.lib.OclReal tudOclNode11=tudOclNode9.subtract(tudOclNode10);
final tudresden.ocl.lib.OclBoolean tudOclNode12=tudOclOpPar0.isLessThan(tudOclNode11);
if(!tudOclNode12.isTrue()){System.out.println("violated ocl precondition 'debitContrainte' on object '"+this+"' operation 'debiter(montant : Integer)'.");throw new Exception("error");}}
{final tudresden.ocl.lib.OclAnyImpl tudOclNode13=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar1=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclReal tudOclNode14=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode13.getFeature("solde"));
tudOclNode15=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode13.getFeature("solde"));
final tudresden.ocl.lib.OclReal tudOclNode16=tudOclNode15.subtract(tudOclOpPar1);
final tudresden.ocl.lib.OclBoolean tudOclNode17=tudOclNode14.isEqualTo(tudOclNode16);
}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
debiter_wrappedbyocl_BanquePackage_Compte(montant);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode13=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar1=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclReal tudOclNode14=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode13.getFeature("solde"));
final tudresden.ocl.lib.OclReal tudOclNode16=tudOclNode15.subtract(tudOclOpPar1);
final tudresden.ocl.lib.OclBoolean tudOclNode17=tudOclNode14.isEqualTo(tudOclNode16);
if(!tudOclNode17.isTrue())System.out.println("violated ocl postcondition 'debitContrainte_1' on object '"+this+"' operation 'debiter(montant : Integer)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #crediter_wrappedbyocl_BanquePackage_Compte(int)
*/public void crediter(int montant)throws Exception{
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
crediter_wrappedbyocl_BanquePackage_Compte(montant);
else{
checkForChangedFeatures();
tudresden.ocl.lib.OclReal tudOclNode15;
tudresden.ocl.lib.OclReal tudOclNode23;
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{final tudresden.ocl.lib.OclAnyImpl tudOclNode18=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar2=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclInteger tudOclNode19=new tudresden.ocl.lib.OclInteger(0);
final tudresden.ocl.lib.OclBoolean tudOclNode20=tudOclOpPar2.isGreaterThan(tudOclNode19);
if(!tudOclNode20.isTrue()){System.out.println("violated ocl precondition 'newConstraint_0' on object '"+this+"' operation 'crediter(montant : Integer)'.");throw new Exception("Error");}}
{final tudresden.ocl.lib.OclAnyImpl tudOclNode21=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar3=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclReal tudOclNode22=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode21.getFeature("solde"));
tudOclNode23=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode21.getFeature("solde"));
final tudresden.ocl.lib.OclReal tudOclNode24=tudOclNode23.add(tudOclOpPar3);
final tudresden.ocl.lib.OclBoolean tudOclNode25=tudOclNode22.isEqualTo(tudOclNode24);
}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
crediter_wrappedbyocl_BanquePackage_Compte(montant);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode21=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar3=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(montant) );
final tudresden.ocl.lib.OclReal tudOclNode22=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode21.getFeature("solde"));
final tudresden.ocl.lib.OclReal tudOclNode24=tudOclNode23.add(tudOclOpPar3);
final tudresden.ocl.lib.OclBoolean tudOclNode25=tudOclNode22.isEqualTo(tudOclNode24);
if(!tudOclNode25.isTrue())System.out.println("violated ocl postcondition 'newConstraint_1' on object '"+this+"' operation 'crediter(montant : Integer)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #getSolde_wrappedbyocl_BanquePackage_Compte()
*/public double getSolde(){
double result;
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
result=getSolde_wrappedbyocl_BanquePackage_Compte();
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
result=getSolde_wrappedbyocl_BanquePackage_Compte();
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
return result;
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #Compte(tudresden.ocl.injection.lib.WrapperDummy)
*/public Compte(){
this((tudresden.ocl.injection.lib.WrapperDummy)null);
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #setProprietaire_wrappedbyocl_BanquePackage_Compte(Personne)
*/public void setProprietaire(Personne p){
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
setProprietaire_wrappedbyocl_BanquePackage_Compte(p);
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
setProprietaire_wrappedbyocl_BanquePackage_Compte(p);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #addLivret_wrappedbyocl_BanquePackage_Compte(Livret)
*/public void addLivret(Livret l){
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
addLivret_wrappedbyocl_BanquePackage_Compte(l);
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{final tudresden.ocl.lib.OclAnyImpl tudOclNode26=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclOpPar4=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(l) );
final tudresden.ocl.lib.OclSequence tudOclNode27=tudresden.ocl.lib.Ocl.toOclSequence(tudOclNode26.getFeature("livret"));
final tudresden.ocl.lib.OclBoolean tudOclNode28=tudOclNode27.excludes(tudOclOpPar4);
if(!tudOclNode28.isTrue())System.out.println("violated ocl precondition 'newConstraint_0' on object '"+this+"' operation 'addLivret(l : Livret)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
addLivret_wrappedbyocl_BanquePackage_Compte(l);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode29=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclOpPar5=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(l) );
final tudresden.ocl.lib.OclSequence tudOclNode30=tudresden.ocl.lib.Ocl.toOclSequence(tudOclNode29.getFeature("livret"));
final tudresden.ocl.lib.OclBoolean tudOclNode31=tudOclNode30.includes(tudOclOpPar5);
if(!tudOclNode31.isTrue())System.out.println("violated ocl postcondition 'newConstraint_1' on object '"+this+"' operation 'addLivret(l : Livret)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #id
*/private int id_oclbackup812374=id;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #id
*/public final java.util.HashSet id_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #solde
*/private double solde_oclbackup812374=solde;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #solde
*/public final java.util.HashSet solde_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #plancher
*/private double plancher_oclbackup812374=plancher;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #plancher
*/public final java.util.HashSet plancher_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #remuneration
*/private double remuneration_oclbackup812374=remuneration;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #remuneration
*/public final java.util.HashSet remuneration_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #proprietaire
*/private Personne proprietaire_oclbackup812374=proprietaire;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #proprietaire
*/public final java.util.HashSet proprietaire_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #livret
*/private int livret_oclbackup812374=0;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #livret
*/public final java.util.HashSet livret_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #gestionnaire
*/private Personne gestionnaire_oclbackup812374=gestionnaire;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #gestionnaire
*/public final java.util.HashSet gestionnaire_oclobservinginvariants812374=new java.util.HashSet();/**
Checks object features, whether they have changed. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private void checkForChangedFeatures(){
if(id!=id_oclbackup812374){id_oclbackup812374=id;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(id_oclobservinginvariants812374);
}
if(solde!=solde_oclbackup812374){solde_oclbackup812374=solde;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(solde_oclobservinginvariants812374);
}
if(plancher!=plancher_oclbackup812374){plancher_oclbackup812374=plancher;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(plancher_oclobservinginvariants812374);
}
if(remuneration!=remuneration_oclbackup812374){remuneration_oclbackup812374=remuneration;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(remuneration_oclobservinginvariants812374);
}
if(proprietaire!=proprietaire_oclbackup812374){proprietaire_oclbackup812374=proprietaire;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(proprietaire_oclobservinginvariants812374);
}
if(tudresden.ocl.injection.lib.HashExact.identityHashCode(livret)!=livret_oclbackup812374){livret_oclbackup812374=tudresden.ocl.injection.lib.HashExact.identityHashCode(livret);
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(livret_oclobservinginvariants812374);
}
if(gestionnaire!=gestionnaire_oclbackup812374){gestionnaire_oclbackup812374=gestionnaire;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(gestionnaire_oclobservinginvariants812374);
}
}/**
An object representing ocl invariant livretContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_livretContrainte=new tudresden.ocl.injection.ocl.lib.Invariant("livretContrainte", this);/**
Checks ocl invariant livretContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_livretContrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_livretContrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode0=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclSequence tudOclNode1=tudresden.ocl.lib.Ocl.toOclSequence(tudOclNode0.getFeature("livret"));
final tudresden.ocl.lib.OclBoolean tudOclNode2=tudOclNode1.notEmpty();
final tudresden.ocl.lib.OclAnyImpl tudOclNode3=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode0.getFeature("proprietaire"));
final tudresden.ocl.lib.OclInteger tudOclNode4=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode3.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode5=new tudresden.ocl.lib.OclInteger(28);
final tudresden.ocl.lib.OclBoolean tudOclNode6=tudOclNode4.isLessEqual(tudOclNode5);
final tudresden.ocl.lib.OclBoolean tudOclNode7=tudOclNode2.implies(tudOclNode6);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode7.isTrue())System.out.println("violated ocl invariant 'livretContrainte' on object '"+this+"'.");
}}