package modelepackage;

import java.util.SortedSet;
import java.util.Vector;

public class Entreprise {
  /* {src_lang=Java}*/


  public String nom;
  /* {transient=false, volatile=false}*/

    /**
   * @postcondition contrainteMasseSalariale: masseSalariale = self . employe . iterate ( p : Personne ; ms : Real = 0 | ms + p . contrat . salaire )
   */
  public double masseSalariale;
  /* {transient=false, volatile=false}*/

    /**
   * @postcondition contrainteTries: salariesTries = self . employe -> sortedBy ( p : Personne | p . contrat . salaire )
   */
  public SortedSet salariesTries;
  /* {transient=false, volatile=false}*/

    /**
   *
   * @element-type Personne
   */
  public Vector  employe;
    /**
   *
   * @element-type Contrat
   */
  public Vector  contrat;

  public Entreprise(tudresden.ocl.injection.lib.WrapperDummy wrappedbyocl) {
  }
/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #Entreprise(tudresden.ocl.injection.lib.WrapperDummy)
*/public Entreprise(){
this((tudresden.ocl.injection.lib.WrapperDummy)null);
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #nom
*/private String nom_oclbackup812374=nom;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #nom
*/public final java.util.HashSet nom_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #masseSalariale
*/private double masseSalariale_oclbackup812374=masseSalariale;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #masseSalariale
*/public final java.util.HashSet masseSalariale_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #salariesTries
*/private int salariesTries_oclbackup812374=0;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #salariesTries
*/public final java.util.HashSet salariesTries_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #employe
*/private int employe_oclbackup812374=0;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #employe
*/public final java.util.HashSet employe_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #contrat
*/private int contrat_oclbackup812374=0;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #contrat
*/public final java.util.HashSet contrat_oclobservinginvariants812374=new java.util.HashSet();/**
Checks object features, whether they have changed. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private void checkForChangedFeatures(){
if(nom!=nom_oclbackup812374){nom_oclbackup812374=nom;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(nom_oclobservinginvariants812374);
}
if(masseSalariale!=masseSalariale_oclbackup812374){masseSalariale_oclbackup812374=masseSalariale;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(masseSalariale_oclobservinginvariants812374);
}
if(tudresden.ocl.injection.lib.HashExact.identityHashCode(salariesTries)!=salariesTries_oclbackup812374){salariesTries_oclbackup812374=tudresden.ocl.injection.lib.HashExact.identityHashCode(salariesTries);
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(salariesTries_oclobservinginvariants812374);
}
if(tudresden.ocl.injection.lib.HashExact.identityHashCode(employe)!=employe_oclbackup812374){employe_oclbackup812374=tudresden.ocl.injection.lib.HashExact.identityHashCode(employe);
if(!tudresden.ocl.injection.lib.Check.checkElementTypes(employe,Personne.class)) System.out.println("element type checker failed at feature 'employe' of object "+this+".");
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(employe_oclobservinginvariants812374);
}
if(tudresden.ocl.injection.lib.HashExact.identityHashCode(contrat)!=contrat_oclbackup812374){contrat_oclbackup812374=tudresden.ocl.injection.lib.HashExact.identityHashCode(contrat);
if(!tudresden.ocl.injection.lib.Check.checkElementTypes(contrat,Contrat.class)) System.out.println("element type checker failed at feature 'contrat' of object "+this+".");
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(contrat_oclobservinginvariants812374);
}
}}