package BanquePackage;

import java.util.Vector;

/*
 * pre:montant>0
 *
 * pre:montant>0
 *
 * post:solde=solde@pre+montant
 *
 * pre:montant>0 and
 * montant<=solde-plancher
 *
 * post:solde=solde@pre-montant
 *
 * inv:solde>=plancher
 */
  /**
   *
   * @invariant livretContrainte: self . livret -> notEmpty implies self . proprietaire . age <= 28
   */
public class Compte {
  /* {src_lang=Java}*/


    /**
   *
   * @precondition newConstraintCrediter: montant > 0
   * @postcondition newConstraintCrediter_1: solde = solde @ pre + montant
   * @precondition newConstraintDebiter: montant <= solde - plancher
   * @postcondition newConstraintDebiter_1: solde = solde @ pre - montant
   */
  protected double solde;
  /* {transient=false, volatile=false}*/

  protected double plancher;
  /* {transient=false, volatile=false}*/

    /**
   *
   * @invariant remunerationContrainte: self . solde < 100 implies remuneration = 0
   * @invariant remunerationContrainte2: if self . solde < 100 then remuneration = self . solde * 0.001 else remuneration = self . solde * 0.005 endif
   */
  protected double remuneration = solde*0.005;
  /* {transient=false, volatile=false}*/

    public Personne proprietaire;
    /**
   *
   * @element-type Livret
   */
  public Vector  livret;
    public Personne gestionnare;

    /**
   *
   * @precondition debitContrainte: montant < solde - plancher
   * @postcondition debitContrainte_1: solde = solde @ pre - montant
   */
  public void debiter(int montant) {
  }

    /**
   *
   * @precondition creditContrainte: montant > 0
   * @postcondition creditContrainte_1: solde = solde @ pre + montant
   */
  public void crediter(int montant) {
  }

  public double getSolde() {
  return 0.0;
  }

  public Compte() {
  }

  public void setProprietaire(Personne p) {
  }

    /**
   *
   * @precondition newConstraint_0: livret -> excludes ( l )
   * @postcondition newConstraint_1: livret -> includes ( l )
   */
  public void addLivret(Livret l) {
  }
}