package BanquePackage;

import java.util.Vector;

  /**
   *
   * @invariant majeurContrainte: self . age < 18 implies self . compte -> isEmpty
   * @invariant agenceContrainte: self . compte -> notEmpty implies self . agence -> notEmpty
   * @invariant gestionContrainte: self . compteGere -> forAll ( c : Compte | c . proprietaire <> self )
   * @invariant contratContrainte: self . contrat -> forAll ( c1 , c2 : Contrat | c1 . id <> c2 . id )
   * @invariant gestionnaireContrainte: self . compte -> exists ( c : Compte | c . gestionnaire -> includes ( self . conseiller ) )
   * @invariant ageContrainte: self . age > 18 implies compte - solde -> sum ( ) > 100
   * @invariant contratContrainte: self . compte -> size > self . contrat -> size
   */
public class Personne {
  /* {src_lang=Java}*/


    /**
   *
   * @invariant ageContarinte: self . age > 0 and self . age < 140
   */
  protected int age;
  /* {transient=false, volatile=false}*/

  protected String nom;
  /* {transient=false, volatile=false}*/

  protected int revenu;
  /* {transient=false, volatile=false}*/

  protected Personne conseiller;
  /* {transient=false, volatile=false}*/

    public Agence agence;
    /**
   *
   * @element-type Contrat
   */
  public Vector  contrat;
    /**
   *
   * @element-type Livret
   */
  public Vector  livret;
    /**
   *
   * @element-type Compte
   */
  public Vector  compte;
    /**
   *
   * @element-type Livret
   */
  public Vector  livretGere;
    /**
   *
   * @element-type Compte
   */
  public Vector  compteGere;

  public Personne() {
  }

  public void setAge(int a) {
  }

  public int getAge() {
  return 0;
  }

  public void setNom(String nom) {
  }

  public String getNom() {
  return null;
  }

    /**
   *
   * @precondition newConstraint_0: compte -> excludes ( c )
   * @postcondition newConstraint_1: compte -> includes ( c )
   */
  public void addCompte(Compte c) {
  }

    /**
   *
   * @precondition newConstraint_0: compteGere -> excludes ( c )
   * @postcondition newConstraint_1: compteGere -> includes ( c )
   */
  public void addCompteGere(Compte c) {
  }

    /**
   *
   * @precondition newConstraint_0: livret -> excludes ( l )
   * @postcondition newConstraint_1: livret -> includes ( l )
   */
  public void addLivret(Livret l) {
  }

    /**
   *
   * @precondition newConstraint_0: livretGere -> excludes ( l )
   * @postcondition newConstraint_1: livretGere -> includes ( l )
   */
  public void addLivretGere(Livret l) {
  }

  public void setRevenu(double revenu) {
  }

  public double getRevenu() {
  return 0.0;
  }

  public void setConseiller(Personne c) {
  }

  public Personne getConseiller() {
  return null;
  }

    /**
   *
   * @precondition newConstraint_0: contrat -> excludes ( c )
   * @postcondition newConstraint_1: contrat -> includes ( c )
   */
  public void addContrat(Contrat c) {
  }
}