package modelepackage;

import java.util.SortedSet;
import java.util.Vector;

public class Entreprise {
  /* {src_lang=Java}*/


  public String nom;
  /* {transient=false, volatile=false}*/

    /**
   * @postcondition contrainteMasseSalariale: masseSalariale = self . employe . iterate ( p : Personne ; ms : Real = 0 | ms + p . contrat . salaire )
   */
  public double masseSalariale;
  /* {transient=false, volatile=false}*/

    /**
   * @postcondition contrainteTries: salariesTries = self . employe -> sortedBy ( p : Personne | p . contrat . salaire )
   */
  public SortedSet salariesTries;
  /* {transient=false, volatile=false}*/

    /**
   *
   * @element-type Personne
   */
  public Vector  employe;
    /**
   *
   * @element-type Contrat
   */
  public Vector  contrat;

  public Entreprise() {
  }
}