package modelepackage;

import java.util.Vector;


  /**
   * @invariant ageContrainte_: marie implies majeur
   * @invariant majeurContrainte: if age >= 18 then majeur = true else majeur = false endif
   * @precondition anniContrainte: age < 140
   * @postcondition anniContrainte_1: age = age @ pre + 1
   * @invariant ageContrainte2: self . age > 0 and self . age < 140
   * @invariant mariecontrainte: marie implies majeur
   * @invariant majeurboolean: majeur = ( age >= 18 )
   * @invariant salaireContrainte: self . contrat . salaire >= 0
   * @precondition anniversairecontrainte: age < 140
   * @postcondition anniversairecontrainte_1: age = age @ pre + 1
   * @invariant contrainteLet: let montantImposable : Real = contrat . salaire * 0.8 in if ( montantImposable >= 100000 ) then impot = montantImposable * 45 / 100 else if ( montantImposable >= 50000 ) then impot = montantImposable * 30 / 100 else impot = montantImposable * 10 / 100 endif endif
   * @invariant ageContrainte3: ageCorrect ( age )
   * @invariant merecontrainte: self . mere <> self and self . age < self . mere . age
   * @postcondition getAgeContrainte: result = age
   */
public class Personne {
  /* {src_lang=Java}*/


    /**
   *
   * @invariant newConstraint_0: self . age > 0 and self . age < 140
   */
  public final int age = 0;
  /* {transient=false, volatile=false}*/

  public boolean marie;
  /* {transient=false, volatile=false}*/

  public boolean majeur;
  /* {transient=false, volatile=false}*/

  public double impot;
  /* {transient=false, volatile=false}*/

  public Personne mere;
  /* {transient=false, volatile=false}*/

    /**
   * @invariant newConstraint_0: if age <= 12 then categorie = 'enfant' else if age <= 18 then categorie = 'ado' else categorie = 'adulte' endif endif
   */
  public String categorie;
  /* {transient=false, volatile=false}*/

    public Personne agentSecretariat;
    public Encadrement encadrement;
    public Personne responsable;

    /**
   *
   * @element-type Voiture
   */
  public Vector  voiture;
    public Entreprise employeur;
    public Contrat myContrat;

    /**
   * @precondition agecontrainteSet2: ageCorrect ( a ) and a >= age
   * @postcondition agecontrainteSet2: age = a
   */
  public void setAge(int a) {
  }

  public Personne() {
  }

    /**
   * @postcondition getAgeContrainte: result = age
   */
  public int getAge() {
  return 0;
  }

    /**
   * @postcondition ageCorrectContrainte: a >= 0 and a <= 140
   */
  public Boolean ageCorrect(int a) {
  return null;
  }

    /**
   * @postcondition contrainteAnniversaire: age < 140 and age = age @ pre + 1
   */
  public void feteAnniversaire() {
  }
}