package modelepackage;

  /**
   * @invariant supContrainte: self . responsable . contrat . salaire >= self . agentSecretariat . contrat . salaire
   * @invariant dateContrainte: self . agentSecretariat . contrat . dateEmbauche <= self . dateDebut
   * @invariant agentAdministratif: self . agentSecretariat . contrat . typeContrat = 'agent administratif'
   */
public class Encadrement {
  /* {src_lang=Java}*/


  public Double dateDebut;
  /* {transient=false, volatile=false}*/

  public String evaluations;
  /* {transient=false, volatile=false}*/

    public Personne responsable;
    public Personne agentSecretariat;

  public Encadrement(tudresden.ocl.injection.lib.WrapperDummy wrappedbyocl) {
  }
/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #Encadrement(tudresden.ocl.injection.lib.WrapperDummy)
*/public Encadrement(){
this((tudresden.ocl.injection.lib.WrapperDummy)null);
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #dateDebut
*/private Double dateDebut_oclbackup812374=dateDebut;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #dateDebut
*/public final java.util.HashSet dateDebut_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #evaluations
*/private String evaluations_oclbackup812374=evaluations;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #evaluations
*/public final java.util.HashSet evaluations_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #responsable
*/private Personne responsable_oclbackup812374=responsable;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #responsable
*/public final java.util.HashSet responsable_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #agentSecretariat
*/private Personne agentSecretariat_oclbackup812374=agentSecretariat;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #agentSecretariat
*/public final java.util.HashSet agentSecretariat_oclobservinginvariants812374=new java.util.HashSet();/**
Checks object features, whether they have changed. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private void checkForChangedFeatures(){
if(dateDebut!=dateDebut_oclbackup812374){dateDebut_oclbackup812374=dateDebut;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(dateDebut_oclobservinginvariants812374);
}
if(evaluations!=evaluations_oclbackup812374){evaluations_oclbackup812374=evaluations;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(evaluations_oclobservinginvariants812374);
}
if(responsable!=responsable_oclbackup812374){responsable_oclbackup812374=responsable;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(responsable_oclobservinginvariants812374);
}
if(agentSecretariat!=agentSecretariat_oclbackup812374){agentSecretariat_oclbackup812374=agentSecretariat;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(agentSecretariat_oclobservinginvariants812374);
}
}/**
An object representing ocl invariant supContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_supContrainte=new tudresden.ocl.injection.ocl.lib.Invariant("supContrainte", this);/**
Checks ocl invariant supContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_supContrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_supContrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode5=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode6=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode5.getFeature("responsable"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode7=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode6.getFeature("contrat"));
final tudresden.ocl.lib.OclReal tudOclNode8=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode7.getFeature("salaire"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode9=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode5.getFeature("agentSecretariat"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode10=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode9.getFeature("contrat"));
final tudresden.ocl.lib.OclReal tudOclNode11=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode10.getFeature("salaire"));
final tudresden.ocl.lib.OclBoolean tudOclNode12=tudOclNode8.isGreaterEqual(tudOclNode11);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode12.isTrue())System.out.println("violated ocl invariant 'supContrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant dateContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_dateContrainte=new tudresden.ocl.injection.ocl.lib.Invariant("dateContrainte", this);/**
Checks ocl invariant dateContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_dateContrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_dateContrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode13=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode14=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode13.getFeature("agentSecretariat"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode15=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode14.getFeature("contrat"));
final tudresden.ocl.lib.OclReal tudOclNode16=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode15.getFeature("dateEmbauche"));
final tudresden.ocl.lib.OclReal tudOclNode17=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode13.getFeature("dateDebut"));
final tudresden.ocl.lib.OclBoolean tudOclNode18=tudOclNode16.isLessEqual(tudOclNode17);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode18.isTrue())System.out.println("violated ocl invariant 'dateContrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant agentAdministratif on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_agentAdministratif=new tudresden.ocl.injection.ocl.lib.Invariant("agentAdministratif", this);/**
Checks ocl invariant agentAdministratif on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_agentAdministratif(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_agentAdministratif);
final tudresden.ocl.lib.OclAnyImpl tudOclNode19=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode20=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode19.getFeature("agentSecretariat"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode21=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode20.getFeature("contrat"));
final tudresden.ocl.lib.OclString tudOclNode22=tudresden.ocl.lib.Ocl.toOclString(tudOclNode21.getFeature("typeContrat"));
final tudresden.ocl.lib.OclString tudOclNode23=new tudresden.ocl.lib.OclString("agent administratif");
final tudresden.ocl.lib.OclBoolean tudOclNode24=tudOclNode22.isEqualTo(tudOclNode23);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode24.isTrue())System.out.println("violated ocl invariant 'agentAdministratif' on object '"+this+"'.");
}}