package modelepackage;

import java.util.Vector;


  /**
   * @invariant ageContrainte_: marie implies majeur
   * @invariant majeurContrainte: if age >= 18 then majeur = true else majeur = false endif
   * @precondition anniContrainte: age < 140
   * @postcondition anniContrainte_1: age = age @ pre + 1
   * @invariant ageContrainte2: self . age > 0 and self . age < 140
   * @invariant mariecontrainte: marie implies majeur
   * @invariant majeurboolean: majeur = ( age >= 18 )
   * @invariant salaireContrainte: self . contrat . salaire >= 0
   * @precondition anniversairecontrainte: age < 140
   * @postcondition anniversairecontrainte_1: age = age @ pre + 1
   * @invariant contrainteLet: let montantImposable : Real = contrat . salaire * 0.8 in if ( montantImposable >= 100000 ) then impot = montantImposable * 45 / 100 else if ( montantImposable >= 50000 ) then impot = montantImposable * 30 / 100 else impot = montantImposable * 10 / 100 endif endif
   * @invariant ageContrainte3: ageCorrect ( age )
   * @invariant merecontrainte: self . mere <> self and self . age < self . mere . age
   * @postcondition getAgeContrainte: result = age
   */
public class Personne {
  /* {src_lang=Java}*/


    /**
   * @invariant ageCostraint: self . age > 0 and self . age < 140
   */
  public final int age = 0;
  /* {transient=false, volatile=false}*/

  public boolean marie;
  /* {transient=false, volatile=false}*/

  public boolean majeur;
  /* {transient=false, volatile=false}*/

  public double impot;
  /* {transient=false, volatile=false}*/

  public Personne mere;
  /* {transient=false, volatile=false}*/

    /**
   * @invariant newConstraint_0: if age <= 12 then categorie = 'enfant' else if age <= 18 then categorie ='ado' else categorie = 'adulte' endif endif
   */
  public String categorie;
  /* {transient=false, volatile=false}*/

    public Personne agentSecretariat;
    public Encadrement encadrement;
    public Personne responsable;

    /**
   *
   * @element-type Voiture
   */
  public Vector  voiture;
    public Entreprise employeur;
    public Contrat contrat;

    /**
   * @precondition agecontrainteSet2: ageCorrect ( a ) and a >= age
   * @postcondition agecontrainteSet2: age = a
   */
  public void setAge_wrappedbyocl_modelepackage_Personne(int a) {
  }

  public Personne(tudresden.ocl.injection.lib.WrapperDummy wrappedbyocl) {
  }

    /**
   * @postcondition getAgeContrainte: result = age
   */
  public int getAge_wrappedbyocl_modelepackage_Personne() {
  return 0;
  }

    /**
   * @postcondition ageCorrectContrainte: a >= 0 and a <= 140
   */
  public Boolean ageCorrect_wrappedbyocl_modelepackage_Personne(int a) {
  return null;
  }

    /**
   * @postcondition contrainteAnniversaire: age < 140 and age = age @ pre + 1
   */
  public void feteAnniversaire_wrappedbyocl_modelepackage_Personne() {
  }
/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #setAge_wrappedbyocl_modelepackage_Personne(int)
*/public void setAge(int a){
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
setAge_wrappedbyocl_modelepackage_Personne(a);
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{final tudresden.ocl.lib.OclAnyImpl tudOclNode126=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar0=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(a) );
Object[] tudOclParam1=new Object[1];
tudOclParam1[0]=tudresden.ocl.lib.Ocl.reconvert(null, tudOclOpPar0);
final tudresden.ocl.lib.OclBoolean tudOclNode127=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode126.getFeature("ageCorrect", tudOclParam1));
final tudresden.ocl.lib.OclInteger tudOclNode128=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode126.getFeature("age"));
final tudresden.ocl.lib.OclBoolean tudOclNode129=tudOclOpPar0.isGreaterEqual(tudOclNode128);
final tudresden.ocl.lib.OclBoolean tudOclNode130=tudOclNode127.and(tudOclNode129);
if(!tudOclNode130.isTrue())System.out.println("violated ocl precondition 'agecontrainteSet2' on object '"+this+"' operation 'setAge(a : Integer)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
setAge_wrappedbyocl_modelepackage_Personne(a);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode131=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar1=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(a) );
final tudresden.ocl.lib.OclInteger tudOclNode132=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode131.getFeature("age"));
final tudresden.ocl.lib.OclBoolean tudOclNode133=tudOclNode132.isEqualTo(tudOclOpPar1);
if(!tudOclNode133.isTrue())System.out.println("violated ocl postcondition 'agecontrainteSet2' on object '"+this+"' operation 'setAge(a : Integer)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #Personne(tudresden.ocl.injection.lib.WrapperDummy)
*/public Personne(){
this((tudresden.ocl.injection.lib.WrapperDummy)null);
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #getAge_wrappedbyocl_modelepackage_Personne()
*/public int getAge(){
int result;
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
result=getAge_wrappedbyocl_modelepackage_Personne();
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
result=getAge_wrappedbyocl_modelepackage_Personne();
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode134=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclResult0=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(result) );
final tudresden.ocl.lib.OclInteger tudOclNode135=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode134.getFeature("age"));
final tudresden.ocl.lib.OclBoolean tudOclNode136=tudOclResult0.isEqualTo(tudOclNode135);
if(!tudOclNode136.isTrue())System.out.println("violated ocl postcondition 'getAgeContrainte' on object '"+this+"' operation 'getAge()'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
return result;
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #ageCorrect_wrappedbyocl_modelepackage_Personne(int)
*/public Boolean ageCorrect(int a){
Boolean result;
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
result=ageCorrect_wrappedbyocl_modelepackage_Personne(a);
else{
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
result=ageCorrect_wrappedbyocl_modelepackage_Personne(a);
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode137=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclOpPar2=tudresden.ocl.lib.Ocl.toOclInteger( tudresden.ocl.lib.Ocl.getFor(a) );
final tudresden.ocl.lib.OclBoolean tudOclResult1=tudresden.ocl.lib.Ocl.toOclBoolean( tudresden.ocl.lib.Ocl.getFor(result) );
final tudresden.ocl.lib.OclInteger tudOclNode138=new tudresden.ocl.lib.OclInteger(0);
final tudresden.ocl.lib.OclBoolean tudOclNode139=tudOclOpPar2.isGreaterEqual(tudOclNode138);
final tudresden.ocl.lib.OclInteger tudOclNode140=new tudresden.ocl.lib.OclInteger(140);
final tudresden.ocl.lib.OclBoolean tudOclNode141=tudOclOpPar2.isLessEqual(tudOclNode140);
final tudresden.ocl.lib.OclBoolean tudOclNode142=tudOclNode139.and(tudOclNode141);
if(!tudOclNode142.isTrue())System.out.println("violated ocl postcondition 'ageCorrectContrainte' on object '"+this+"' operation 'ageCorrect(a : Integer)'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
return result;
}/**
A wrapper for injection. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #feteAnniversaire_wrappedbyocl_modelepackage_Personne()
*/public void feteAnniversaire(){
if(tudresden.ocl.injection.ocl.lib.Invariant.checking_flag)
feteAnniversaire_wrappedbyocl_modelepackage_Personne();
else{
checkForChangedFeatures();
tudresden.ocl.lib.OclInteger tudOclNode148;
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{final tudresden.ocl.lib.OclAnyImpl tudOclNode143=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode144=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode143.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode145=new tudresden.ocl.lib.OclInteger(140);
final tudresden.ocl.lib.OclBoolean tudOclNode146=tudOclNode144.isLessThan(tudOclNode145);
final tudresden.ocl.lib.OclInteger tudOclNode147=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode143.getFeature("age"));
tudOclNode148=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode143.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode149=new tudresden.ocl.lib.OclInteger(1);
final tudresden.ocl.lib.OclInteger tudOclNode150=tudOclNode148.add(tudOclNode149);
final tudresden.ocl.lib.OclBoolean tudOclNode151=tudOclNode147.isEqualTo(tudOclNode150);
final tudresden.ocl.lib.OclBoolean tudOclNode152=tudOclNode146.and(tudOclNode151);
}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
feteAnniversaire_wrappedbyocl_modelepackage_Personne();
checkForChangedFeatures();
try{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=true;
tudresden.ocl.injection.ocl.lib.Invariant.checkVacantInvariants();
{
final tudresden.ocl.lib.OclAnyImpl tudOclNode143=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode144=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode143.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode145=new tudresden.ocl.lib.OclInteger(140);
final tudresden.ocl.lib.OclBoolean tudOclNode146=tudOclNode144.isLessThan(tudOclNode145);
final tudresden.ocl.lib.OclInteger tudOclNode147=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode143.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode149=new tudresden.ocl.lib.OclInteger(1);
final tudresden.ocl.lib.OclInteger tudOclNode150=tudOclNode148.add(tudOclNode149);
final tudresden.ocl.lib.OclBoolean tudOclNode151=tudOclNode147.isEqualTo(tudOclNode150);
final tudresden.ocl.lib.OclBoolean tudOclNode152=tudOclNode146.and(tudOclNode151);
if(!tudOclNode152.isTrue())System.out.println("violated ocl postcondition 'contrainteAnniversaire' on object '"+this+"' operation 'feteAnniversaire()'.");}
}finally{tudresden.ocl.injection.ocl.lib.Invariant.checking_flag=false;}
}
}/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #marie
*/private boolean marie_oclbackup812374=marie;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #marie
*/public final java.util.HashSet marie_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #majeur
*/private boolean majeur_oclbackup812374=majeur;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #majeur
*/public final java.util.HashSet majeur_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #impot
*/private double impot_oclbackup812374=impot;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #impot
*/public final java.util.HashSet impot_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #mere
*/private Personne mere_oclbackup812374=mere;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #mere
*/public final java.util.HashSet mere_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #categorie
*/private String categorie_oclbackup812374=categorie;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #categorie
*/public final java.util.HashSet categorie_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #agentSecretariat
*/private Personne agentSecretariat_oclbackup812374=agentSecretariat;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #agentSecretariat
*/public final java.util.HashSet agentSecretariat_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #encadrement
*/private Encadrement encadrement_oclbackup812374=encadrement;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #encadrement
*/public final java.util.HashSet encadrement_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #responsable
*/private Personne responsable_oclbackup812374=responsable;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #responsable
*/public final java.util.HashSet responsable_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #voiture
*/private int voiture_oclbackup812374=0;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #voiture
*/public final java.util.HashSet voiture_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #employeur
*/private Entreprise employeur_oclbackup812374=employeur;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #employeur
*/public final java.util.HashSet employeur_oclobservinginvariants812374=new java.util.HashSet();/**
A backup for detecting modifications. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #contrat
*/private Contrat contrat_oclbackup812374=contrat;/**
Contains observers for modifications of this feature. Generated automatically, DO NOT CHANGE!
@author ocl_injector
@see #contrat
*/public final java.util.HashSet contrat_oclobservinginvariants812374=new java.util.HashSet();/**
Checks object features, whether they have changed. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private void checkForChangedFeatures(){
if(marie!=marie_oclbackup812374){marie_oclbackup812374=marie;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(marie_oclobservinginvariants812374);
}
if(majeur!=majeur_oclbackup812374){majeur_oclbackup812374=majeur;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(majeur_oclobservinginvariants812374);
}
if(impot!=impot_oclbackup812374){impot_oclbackup812374=impot;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(impot_oclobservinginvariants812374);
}
if(mere!=mere_oclbackup812374){mere_oclbackup812374=mere;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(mere_oclobservinginvariants812374);
}
if(categorie!=categorie_oclbackup812374){categorie_oclbackup812374=categorie;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(categorie_oclobservinginvariants812374);
}
if(agentSecretariat!=agentSecretariat_oclbackup812374){agentSecretariat_oclbackup812374=agentSecretariat;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(agentSecretariat_oclobservinginvariants812374);
}
if(encadrement!=encadrement_oclbackup812374){encadrement_oclbackup812374=encadrement;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(encadrement_oclobservinginvariants812374);
}
if(responsable!=responsable_oclbackup812374){responsable_oclbackup812374=responsable;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(responsable_oclobservinginvariants812374);
}
if(tudresden.ocl.injection.lib.HashExact.identityHashCode(voiture)!=voiture_oclbackup812374){voiture_oclbackup812374=tudresden.ocl.injection.lib.HashExact.identityHashCode(voiture);
if(!tudresden.ocl.injection.lib.Check.checkElementTypes(voiture,Voiture.class)) System.out.println("element type checker failed at feature 'voiture' of object "+this+".");
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(voiture_oclobservinginvariants812374);
}
if(employeur!=employeur_oclbackup812374){employeur_oclbackup812374=employeur;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(employeur_oclobservinginvariants812374);
}
if(contrat!=contrat_oclbackup812374){contrat_oclbackup812374=contrat;
tudresden.ocl.injection.ocl.lib.Invariant.notifyObservingInvariants(contrat_oclobservinginvariants812374);
}
}/**
An object representing ocl invariant ageContrainte_ on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_ageContrainte_=new tudresden.ocl.injection.ocl.lib.Invariant("ageContrainte_", this);/**
Checks ocl invariant ageContrainte_ on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_ageContrainte_(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_ageContrainte_);
final tudresden.ocl.lib.OclAnyImpl tudOclNode25=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclBoolean tudOclNode26=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode25.getFeature("marie"));
final tudresden.ocl.lib.OclBoolean tudOclNode27=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode25.getFeature("majeur"));
final tudresden.ocl.lib.OclBoolean tudOclNode28=tudOclNode26.implies(tudOclNode27);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode28.isTrue())System.out.println("violated ocl invariant 'ageContrainte_' on object '"+this+"'.");
}/**
An object representing ocl invariant majeurContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_majeurContrainte=new tudresden.ocl.injection.ocl.lib.Invariant("majeurContrainte", this);/**
Checks ocl invariant majeurContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_majeurContrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_majeurContrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode29=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode30=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode29.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode31=new tudresden.ocl.lib.OclInteger(18);
final tudresden.ocl.lib.OclBoolean tudOclNode32=tudOclNode30.isGreaterEqual(tudOclNode31);
final tudresden.ocl.lib.OclBoolean tudOclNode33=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode29.getFeature("majeur"));
final tudresden.ocl.lib.OclBoolean tudOclNode34=tudresden.ocl.lib.OclBoolean.TRUE;
final tudresden.ocl.lib.OclBoolean tudOclNode35=tudOclNode33.isEqualTo(tudOclNode34);
final tudresden.ocl.lib.OclBoolean tudOclNode36=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode29.getFeature("majeur"));
final tudresden.ocl.lib.OclBoolean tudOclNode37=tudresden.ocl.lib.OclBoolean.FALSE;
final tudresden.ocl.lib.OclBoolean tudOclNode38=tudOclNode36.isEqualTo(tudOclNode37);
final tudresden.ocl.lib.OclBoolean tudOclNode39=(tudOclNode32.isTrue()) ? (tudOclNode35) : (tudOclNode38);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode39.isTrue())System.out.println("violated ocl invariant 'majeurContrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant ageContrainte2 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_ageContrainte2=new tudresden.ocl.injection.ocl.lib.Invariant("ageContrainte2", this);/**
Checks ocl invariant ageContrainte2 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_ageContrainte2(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_ageContrainte2);
final tudresden.ocl.lib.OclAnyImpl tudOclNode40=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode41=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode40.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode42=new tudresden.ocl.lib.OclInteger(0);
final tudresden.ocl.lib.OclBoolean tudOclNode43=tudOclNode41.isGreaterThan(tudOclNode42);
final tudresden.ocl.lib.OclInteger tudOclNode44=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode40.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode45=new tudresden.ocl.lib.OclInteger(140);
final tudresden.ocl.lib.OclBoolean tudOclNode46=tudOclNode44.isLessThan(tudOclNode45);
final tudresden.ocl.lib.OclBoolean tudOclNode47=tudOclNode43.and(tudOclNode46);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode47.isTrue())System.out.println("violated ocl invariant 'ageContrainte2' on object '"+this+"'.");
}/**
An object representing ocl invariant mariecontrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_mariecontrainte=new tudresden.ocl.injection.ocl.lib.Invariant("mariecontrainte", this);/**
Checks ocl invariant mariecontrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_mariecontrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_mariecontrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode48=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclBoolean tudOclNode49=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode48.getFeature("marie"));
final tudresden.ocl.lib.OclBoolean tudOclNode50=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode48.getFeature("majeur"));
final tudresden.ocl.lib.OclBoolean tudOclNode51=tudOclNode49.implies(tudOclNode50);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode51.isTrue())System.out.println("violated ocl invariant 'mariecontrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant majeurboolean on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_majeurboolean=new tudresden.ocl.injection.ocl.lib.Invariant("majeurboolean", this);/**
Checks ocl invariant majeurboolean on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_majeurboolean(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_majeurboolean);
final tudresden.ocl.lib.OclAnyImpl tudOclNode52=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclBoolean tudOclNode53=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode52.getFeature("majeur"));
final tudresden.ocl.lib.OclInteger tudOclNode54=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode52.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode55=new tudresden.ocl.lib.OclInteger(18);
final tudresden.ocl.lib.OclBoolean tudOclNode56=tudOclNode54.isGreaterEqual(tudOclNode55);
final tudresden.ocl.lib.OclBoolean tudOclNode57=tudOclNode53.isEqualTo(tudOclNode56);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode57.isTrue())System.out.println("violated ocl invariant 'majeurboolean' on object '"+this+"'.");
}/**
An object representing ocl invariant salaireContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_salaireContrainte=new tudresden.ocl.injection.ocl.lib.Invariant("salaireContrainte", this);/**
Checks ocl invariant salaireContrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_salaireContrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_salaireContrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode58=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode59=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode58.getFeature("contrat"));
final tudresden.ocl.lib.OclReal tudOclNode60=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode59.getFeature("salaire"));
final tudresden.ocl.lib.OclInteger tudOclNode61=new tudresden.ocl.lib.OclInteger(0);
final tudresden.ocl.lib.OclBoolean tudOclNode62=tudOclNode60.isGreaterEqual(tudOclNode61);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode62.isTrue())System.out.println("violated ocl invariant 'salaireContrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant contrainteLet on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_contrainteLet=new tudresden.ocl.injection.ocl.lib.Invariant("contrainteLet", this);/**
Checks ocl invariant contrainteLet on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_contrainteLet(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_contrainteLet);
final tudresden.ocl.lib.OclAnyImpl tudOclNode63=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode64=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode63.getFeature("contrat"));
final tudresden.ocl.lib.OclReal tudOclNode65=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode64.getFeature("salaire"));
final tudresden.ocl.lib.OclReal tudOclNode66=new tudresden.ocl.lib.OclReal(0.8);
final tudresden.ocl.lib.OclReal tudOclNode67=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode65).multiply(tudOclNode66);
final tudresden.ocl.lib.OclInteger tudOclNode68=new tudresden.ocl.lib.OclInteger(100000);
final tudresden.ocl.lib.OclBoolean tudOclNode69=tudOclNode67.isGreaterEqual(tudOclNode68);
final tudresden.ocl.lib.OclReal tudOclNode70=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode63.getFeature("impot"));
final tudresden.ocl.lib.OclInteger tudOclNode71=new tudresden.ocl.lib.OclInteger(45);
final tudresden.ocl.lib.OclInteger tudOclNode72=new tudresden.ocl.lib.OclInteger(100);
final tudresden.ocl.lib.OclReal tudOclNode73=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode67).multiply(tudOclNode71).divide(tudOclNode72);
final tudresden.ocl.lib.OclBoolean tudOclNode74=tudOclNode70.isEqualTo(tudOclNode73);
final tudresden.ocl.lib.OclInteger tudOclNode75=new tudresden.ocl.lib.OclInteger(50000);
final tudresden.ocl.lib.OclBoolean tudOclNode76=tudOclNode67.isGreaterEqual(tudOclNode75);
final tudresden.ocl.lib.OclReal tudOclNode77=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode63.getFeature("impot"));
final tudresden.ocl.lib.OclInteger tudOclNode78=new tudresden.ocl.lib.OclInteger(30);
final tudresden.ocl.lib.OclInteger tudOclNode79=new tudresden.ocl.lib.OclInteger(100);
final tudresden.ocl.lib.OclReal tudOclNode80=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode67).multiply(tudOclNode78).divide(tudOclNode79);
final tudresden.ocl.lib.OclBoolean tudOclNode81=tudOclNode77.isEqualTo(tudOclNode80);
final tudresden.ocl.lib.OclReal tudOclNode82=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode63.getFeature("impot"));
final tudresden.ocl.lib.OclInteger tudOclNode83=new tudresden.ocl.lib.OclInteger(10);
final tudresden.ocl.lib.OclInteger tudOclNode84=new tudresden.ocl.lib.OclInteger(100);
final tudresden.ocl.lib.OclReal tudOclNode85=tudresden.ocl.lib.Ocl.toOclReal(tudOclNode67).multiply(tudOclNode83).divide(tudOclNode84);
final tudresden.ocl.lib.OclBoolean tudOclNode86=tudOclNode82.isEqualTo(tudOclNode85);
final tudresden.ocl.lib.OclBoolean tudOclNode87=(tudOclNode76.isTrue()) ? (tudOclNode81) : (tudOclNode86);
final tudresden.ocl.lib.OclBoolean tudOclNode88=(tudOclNode69.isTrue()) ? (tudOclNode74) : (tudOclNode87);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode88.isTrue())System.out.println("violated ocl invariant 'contrainteLet' on object '"+this+"'.");
}/**
An object representing ocl invariant ageContrainte3 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_ageContrainte3=new tudresden.ocl.injection.ocl.lib.Invariant("ageContrainte3", this);/**
Checks ocl invariant ageContrainte3 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_ageContrainte3(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_ageContrainte3);
final tudresden.ocl.lib.OclAnyImpl tudOclNode89=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode90=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode89.getFeature("age"));
Object[] tudOclParam0=new Object[1];
tudOclParam0[0]=tudresden.ocl.lib.Ocl.reconvert(null, tudOclNode90);
final tudresden.ocl.lib.OclBoolean tudOclNode91=tudresden.ocl.lib.Ocl.toOclBoolean(tudOclNode89.getFeature("ageCorrect", tudOclParam0));
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode91.isTrue())System.out.println("violated ocl invariant 'ageContrainte3' on object '"+this+"'.");
}/**
An object representing ocl invariant merecontrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_merecontrainte=new tudresden.ocl.injection.ocl.lib.Invariant("merecontrainte", this);/**
Checks ocl invariant merecontrainte on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_merecontrainte(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_merecontrainte);
final tudresden.ocl.lib.OclAnyImpl tudOclNode92=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclAnyImpl tudOclNode93=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode92.getFeature("mere"));
final tudresden.ocl.lib.OclBoolean tudOclNode94=tudOclNode93.isNotEqualTo(tudOclNode92);
final tudresden.ocl.lib.OclInteger tudOclNode95=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode92.getFeature("age"));
final tudresden.ocl.lib.OclAnyImpl tudOclNode96=tudresden.ocl.lib.Ocl.toOclAnyImpl(tudOclNode92.getFeature("mere"));
final tudresden.ocl.lib.OclInteger tudOclNode97=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode96.getFeature("age"));
final tudresden.ocl.lib.OclBoolean tudOclNode98=tudOclNode95.isLessThan(tudOclNode97);
final tudresden.ocl.lib.OclBoolean tudOclNode99=tudOclNode94.and(tudOclNode98);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode99.isTrue())System.out.println("violated ocl invariant 'merecontrainte' on object '"+this+"'.");
}/**
An object representing ocl invariant ageCostraint on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_ageCostraint=new tudresden.ocl.injection.ocl.lib.Invariant("ageCostraint", this);/**
Checks ocl invariant ageCostraint on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_ageCostraint(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_ageCostraint);
final tudresden.ocl.lib.OclAnyImpl tudOclNode100=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode101=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode100.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode102=new tudresden.ocl.lib.OclInteger(0);
final tudresden.ocl.lib.OclBoolean tudOclNode103=tudOclNode101.isGreaterThan(tudOclNode102);
final tudresden.ocl.lib.OclInteger tudOclNode104=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode100.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode105=new tudresden.ocl.lib.OclInteger(140);
final tudresden.ocl.lib.OclBoolean tudOclNode106=tudOclNode104.isLessThan(tudOclNode105);
final tudresden.ocl.lib.OclBoolean tudOclNode107=tudOclNode103.and(tudOclNode106);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode107.isTrue())System.out.println("violated ocl invariant 'ageCostraint' on object '"+this+"'.");
}/**
An object representing ocl invariant newConstraint_0 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/private final tudresden.ocl.injection.ocl.lib.Invariant zzzCheckOclInvariantObject812374_newConstraint_0=new tudresden.ocl.injection.ocl.lib.Invariant("newConstraint_0", this);/**
Checks ocl invariant newConstraint_0 on this object. Generated automatically, DO NOT CHANGE!
@author ocl_injector
*/public final void zzzCheckOclInvariantMethod812374_newConstraint_0(){
tudresden.ocl.lib.OclAnyImpl.setFeatureListener(zzzCheckOclInvariantObject812374_newConstraint_0);
final tudresden.ocl.lib.OclAnyImpl tudOclNode108=tudresden.ocl.lib.Ocl.toOclAnyImpl( tudresden.ocl.lib.Ocl.getFor(this) );
final tudresden.ocl.lib.OclInteger tudOclNode109=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode108.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode110=new tudresden.ocl.lib.OclInteger(12);
final tudresden.ocl.lib.OclBoolean tudOclNode111=tudOclNode109.isLessEqual(tudOclNode110);
final tudresden.ocl.lib.OclString tudOclNode112=tudresden.ocl.lib.Ocl.toOclString(tudOclNode108.getFeature("categorie"));
final tudresden.ocl.lib.OclString tudOclNode113=new tudresden.ocl.lib.OclString("enfant");
final tudresden.ocl.lib.OclBoolean tudOclNode114=tudOclNode112.isEqualTo(tudOclNode113);
final tudresden.ocl.lib.OclInteger tudOclNode115=tudresden.ocl.lib.Ocl.toOclInteger(tudOclNode108.getFeature("age"));
final tudresden.ocl.lib.OclInteger tudOclNode116=new tudresden.ocl.lib.OclInteger(18);
final tudresden.ocl.lib.OclBoolean tudOclNode117=tudOclNode115.isLessEqual(tudOclNode116);
final tudresden.ocl.lib.OclString tudOclNode118=tudresden.ocl.lib.Ocl.toOclString(tudOclNode108.getFeature("categorie"));
final tudresden.ocl.lib.OclString tudOclNode119=new tudresden.ocl.lib.OclString("ado");
final tudresden.ocl.lib.OclBoolean tudOclNode120=tudOclNode118.isEqualTo(tudOclNode119);
final tudresden.ocl.lib.OclString tudOclNode121=tudresden.ocl.lib.Ocl.toOclString(tudOclNode108.getFeature("categorie"));
final tudresden.ocl.lib.OclString tudOclNode122=new tudresden.ocl.lib.OclString("adulte");
final tudresden.ocl.lib.OclBoolean tudOclNode123=tudOclNode121.isEqualTo(tudOclNode122);
final tudresden.ocl.lib.OclBoolean tudOclNode124=(tudOclNode117.isTrue()) ? (tudOclNode120) : (tudOclNode123);
final tudresden.ocl.lib.OclBoolean tudOclNode125=(tudOclNode111.isTrue()) ? (tudOclNode114) : (tudOclNode124);
tudresden.ocl.lib.OclAnyImpl.clearFeatureListener();
if(!tudOclNode125.isTrue())System.out.println("violated ocl invariant 'newConstraint_0' on object '"+this+"'.");
}}